/************************************************************************
 *
 *  panel_api.h
 *
 ************************************************************************/

#ifndef PANEL_API_API_H
#define PANEL_API_API_H

#define S_OK	0
#define S_FALSE -1
/************************************************************************
 *  Include files
 ************************************************************************/


/************************************************************************
 *  Public functions
 ************************************************************************/

void panel_customized_setting(void);
typedef enum _LG_EPI_GAMMA_VOLTAGE{
	LG_EPI_GAMMA_VOLTAGE_43UHD	= 0,
	LG_EPI_GAMMA_VOLTAGE_49UHD	= 1,
	LG_EPI_GAMMA_VOLTAGE_55UHD	= 2,
}LG_EPI_GAMMA_VOLTAGE;
unsigned char  panel_epi_gamma_i2c_control(void);
unsigned char panel_tcon_i2c_control(void);

#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR)  || defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G)
typedef enum {
    // x81s x81u s8000
	_SPEAKER_12V, 
	// x82s
	_SPEAKER_18V, 
	// v90
	_SPEAKER_24V,
}SPEAKER_OUTPUT_TYPE;	//SPEAKER_OUTPUT_TYPE;

unsigned char panel_custom_mode(void); 
SPEAKER_OUTPUT_TYPE panel_custom_amp_volume_table_index(void);
#endif

void panel_mLVDS_CSOT_tcon_setting(void);
void panel_mLVDS_BOE_default_tcon_tx(void);
void panel_mLVDS_BOE_tcon_setting(void);
void panel_mLVDS_Sharp_70_Inch_tcon_setting(void);
void panel_mLVDS_CSOT_GOA_tcon_setting(void);

void panel_chpi_55inch_uhd60_6lane_himax(void);
void panel_chpi_55inch_uhd60_6lane_ilitek(void);
void panel_chpi_55inch_uhd60_6lane_raydium(void);
void panel_chpi_bc_trigger(void);
void panel_isp_50inch_uhd60_12lane(void);

void panel_epi_lc430dgg_uhd60_12lane_tcon_setting(void);
void panel_epi_lc550dgg_uhd60_12lane_tcon_setting(void);
void panel_epi_lc430egg_uhd60_6lane_tcon_setting(void);
void panel_epi_lc550egg_uhd60_6lane_tcon_setting(void);
void panel_epi_lc490egg_uhd60_6lane_tcon_setting(void);
void panel_epi_v18_65inch_uhd60_8lane_tcon_setting(void);

void panel_ceds_hv490qub_uhd60_12lane_tcon_setting(void);
void panel_ceds_BOE_HV550QUB_H81_tcon_setting(void);


/************************************************************************
 *  Private functions
 ************************************************************************/


#if 1//yuan
#define Bin_Num_Output_InvOutput_Gamma 256
#define VIP_Demura_Encode_TBL_ROW 136/*271*/
#define VIP_Demura_Encode_TBL_COL 1680/*3312*/
#define VIP_Demura_Encode_TBL_ROW_B 271/*271*/
#define VIP_Demura_Encode_TBL_COL_B 3312/*3312*/
#define OD_table_length	289

typedef enum _SCALER_DISP_CHANNEL{
	SLR_MAIN_DISPLAY = 0,
	SLR_SUB_DISPLAY
}SCALER_DISP_CHANNEL;

typedef enum _VIP_GAMMA_CHANNEL_RGB {
	GAMMA_CHANNEL_R = 0,
	GAMMA_CHANNEL_G,
	GAMMA_CHANNEL_B,
	VIP_GAMMA_CHANNEL_RGB_MAX,
	GAMMA_CHANNEL_W,
} VIP_GAMMA_CHANNEL_RGB;

typedef struct _TconTable_HEADER {
        int                            iSize;                        //Total array size
        int                            iTableArraySize;      // array size
        int                            iIndexTableSize;
        unsigned char         iTableType;             //PANEL_TABLE_TYPE
        unsigned char         iTableArrayLen; 
        unsigned char         iIndexTableLen;
        unsigned char         reserved;                 // reserved to keep picmode tableLen
}TconTable_HEADER;

typedef struct _VIP_Output_InvOutput_Gamma_CTRL_ITEM{
	unsigned int output_Gamma_En;
	unsigned int output_Location;
	unsigned int output_format;
	unsigned int reserved1;
} VIP_Output_InvOutput_Gamma_CTRL_ITEM;

typedef struct _VIP_Output_Gamma_TBL{
	unsigned int TBL_R[Bin_Num_Output_InvOutput_Gamma/2];
	unsigned int TBL_G[Bin_Num_Output_InvOutput_Gamma/2];
	unsigned int TBL_B[Bin_Num_Output_InvOutput_Gamma/2];
	unsigned int TBL_W[Bin_Num_Output_InvOutput_Gamma/2];

} VIP_Output_Gamma_TBL;

typedef struct _VIP_Output_Gamma{
	VIP_Output_InvOutput_Gamma_CTRL_ITEM Output_InvOutput_Gamma_CTRL_ITEM;
	VIP_Output_Gamma_TBL Output_Gamma_TBL;
} VIP_Output_Gamma;
//==========================================================
typedef enum _VIP_DeMura_TBL_Mode {
	DeMura_TBL_241x136 = 0,
	DeMura_TBL_481x271,

	VIP_DeMura_TBL_Mode_MAX,
} VIP_DeMura_TBL_Mode;

typedef struct  _DRV_DeMura_CTRL_TBL {
	unsigned int demura_table_scale;
	unsigned int demura_block_size;
	unsigned int demura_rgb_table_seperate;
	unsigned int demura_en;

	unsigned int demura_r_upper_cutoff;
	unsigned int demura_r_lower_cutoff;
	unsigned int demura_r_m_level;
	unsigned int demura_r_l_level;
	unsigned int demura_r_h_level;
	unsigned int r_div_factor_l_m;
	unsigned int r_div_factor_l;
	unsigned int r_div_factor_h;
	unsigned int r_div_factor_m_h;

	unsigned int demura_g_upper_cutoff;
	unsigned int demura_g_lower_cutoff;
	unsigned int demura_g_m_level;
	unsigned int demura_g_l_level;
	unsigned int demura_g_h_level;
	unsigned int g_div_factor_l_m;
	unsigned int g_div_factor_l;
	unsigned int g_div_factor_h;
	unsigned int g_div_factor_m_h;

	unsigned int demura_b_upper_cutoff;
	unsigned int demura_b_lower_cutoff;
	unsigned int demura_b_m_level;
	unsigned int demura_b_l_level;
	unsigned int demura_b_h_level;
	unsigned int b_div_factor_l_m;
	unsigned int b_div_factor_l;
	unsigned int b_div_factor_h;
	unsigned int b_div_factor_m_h;
} DRV_DeMura_CTRL_TBL;

typedef struct  _DRV_DeMura_DMA_TBL {
	unsigned int burst_len;
	unsigned int line_128_num;
	unsigned int line_step;
	unsigned int table_height;
	unsigned int table_width;

} DRV_DeMura_DMA_TBL;

//==========================================================
typedef enum {
	_PCID2_COLOR_R = 0,
	_PCID2_COLOR_G,
	_PCID2_COLOR_B,
	_PCID2_COLOR_ALL,
	_PCID2_COLOR_ERR
} DRV_pcid2_channel_t;

typedef struct
{
	bool valc_en;
	unsigned char hpf_clip;
	unsigned char hpf_weight[16];
	unsigned char sat_weight[16];
} DRV_pcid_valc_t;

typedef struct {
	unsigned char line_sel;
	unsigned char point_sel;
	unsigned char color_sel;
} DRV_pcid2_pixel_ref_setting_t;

typedef struct {
	DRV_pcid2_pixel_ref_setting_t line1_even_r;
	DRV_pcid2_pixel_ref_setting_t line1_even_g;
	DRV_pcid2_pixel_ref_setting_t line1_even_b;

	DRV_pcid2_pixel_ref_setting_t line1_odd_r;
	DRV_pcid2_pixel_ref_setting_t line1_odd_g;
	DRV_pcid2_pixel_ref_setting_t line1_odd_b;

	DRV_pcid2_pixel_ref_setting_t line2_even_r;
	DRV_pcid2_pixel_ref_setting_t line2_even_g;
	DRV_pcid2_pixel_ref_setting_t line2_even_b;

	DRV_pcid2_pixel_ref_setting_t line2_odd_r;
	DRV_pcid2_pixel_ref_setting_t line2_odd_g;
	DRV_pcid2_pixel_ref_setting_t line2_odd_b;

	DRV_pcid2_pixel_ref_setting_t line3_even_r;
	DRV_pcid2_pixel_ref_setting_t line3_even_g;
	DRV_pcid2_pixel_ref_setting_t line3_even_b;

	DRV_pcid2_pixel_ref_setting_t line3_odd_r;
	DRV_pcid2_pixel_ref_setting_t line3_odd_g;
	DRV_pcid2_pixel_ref_setting_t line3_odd_b;

	DRV_pcid2_pixel_ref_setting_t line4_even_r;
	DRV_pcid2_pixel_ref_setting_t line4_even_g;
	DRV_pcid2_pixel_ref_setting_t line4_even_b;

	DRV_pcid2_pixel_ref_setting_t line4_odd_r;
	DRV_pcid2_pixel_ref_setting_t line4_odd_g;
	DRV_pcid2_pixel_ref_setting_t line4_odd_b;

} DRV_pcid2_ref_setting_t;

typedef struct {
	// LSB addition
	unsigned char lsb_add_en;
	unsigned char lsb_add_nr_en;
	unsigned char lsb_add_slope_check_en;
	unsigned char lsb_add_nr_thd;
	// Noise reduction
	unsigned char pcid_thd_en;
	unsigned char pcid_thd_mode;
	unsigned char pcid_tbl1_r_th;
	unsigned char pcid_tbl1_g_th;
	unsigned char pcid_tbl1_b_th;
	unsigned char pcid_tbl2_r_th;
	unsigned char pcid_tbl2_g_th;
	unsigned char pcid_tbl2_b_th;
	// XTR
	unsigned char xtr_tbl1_en;
	unsigned char xtr_tbl2_en;
	// Mode selection
	unsigned char boundary_mode;
	// Subpixel reference setting
	DRV_pcid2_ref_setting_t pixel_ref;
	} DRV_pcid2_data_t;


typedef struct _VIP_valc_CTRL_ITEM{
        unsigned char pod_en;
        unsigned char pcid_en;
        unsigned char valc_en;
        unsigned char reserved1;
} VIP_valc_CTRL_ITEM;

typedef struct {
	DRV_pcid2_data_t pcid2_data;
	unsigned char pPcid2PolTable[3][8];
	DRV_pcid_valc_t pcid_valc;
} DRV_POD_DATA_table_t;

//==========================================================
typedef struct _VIP_OD_CTRL_ITEM{
	unsigned int od_en;
	unsigned int od_table_type;
	unsigned int od_deta_gain_r;
	unsigned int od_deta_gain_g;
	unsigned int od_deta_gain_b;
	unsigned int od_deta_gain_w;
	unsigned int frame_limit_bit;
	
	unsigned int nr_mode;//7
	unsigned int nr_r_en;
	unsigned int nr_g_en;
	unsigned int nr_b_en;
	unsigned int nr_w_en;

	unsigned int nr_r_th;
	unsigned int nr_g_th;
	unsigned int nr_b_th;
	unsigned int nr_w_th;
} VIP_OD_CTRL_ITEM;

//==========================================================

void GetOutputGamma_BinFileParameters(void);
void kdrvif_color_output_gamma_control_front(unsigned char display);
void kdrvif_color_output_gamma_control_back(unsigned char display);
void kdrvif_color_colorwrite_output_gamma(unsigned int *pArray, VIP_GAMMA_CHANNEL_RGB RGB_chanel_idx);
void kdrvif_color_set_output_gamma_format(unsigned char Enable, unsigned char fmt, unsigned char loc, unsigned char ch_order);
void fwif_color_ChangeUINT32Endian_Copy(unsigned int  *pwTemp , int nSize, unsigned int  *pwCopyTemp, unsigned char convert_endian_flag);
unsigned int Scaler_ChangeUINT32Endian(unsigned int a_ulLittleIndian);


void GetVALC_BinFileParameters(void);
void kdrvif_color_pcid2_enable(unsigned char bpcid2);
void kfwif_color_set_PCID_VALCSetting(void);
void kfwif_color_set_pcid2_valuetable_bycolor(unsigned char* InputLUT, DRV_pcid2_channel_t Channel);
void kdrvif_color_pcid2_valuetable(unsigned int * ValueTBL, unsigned int TblSel, DRV_pcid2_channel_t Channel);
void kdrvif_color_pcid_enable(unsigned char bpcid_enable);
void kdrvif_color_pcid_VALC_protection(void);
void kdrvif_color_pcid_VALC_enable(unsigned char ucEnable);


void GetDemura_BinFileParameters(void);
char kdrvif_color_set_DeMura(unsigned int *ptr, unsigned int *pArray, unsigned char DemuraTBLformat);
char fwif_color_set_DeMura_En(unsigned char enable);
void kdrvif_color_set_DeMura_En(unsigned char enable);
unsigned int drvif_memory_get_data_align(unsigned int Value, unsigned int unit);


void GetOD_BinFileParameters(void);
void kdrvif_color_od(unsigned int *ptr);
bool fwif_color_od_init(UINT8 color_depth_bits, UINT8 dma_mode, UINT8 freq);
void drvif_color_od_Ymode(void);
bool drvif_color_od_pqc(UINT16 height, UINT16 width, UINT8 bit_sel, UINT8 dma_mode, UINT8 FrameLimitBit, int dataColor, int dataFormat);
unsigned char fwif_color_set_od_table(unsigned int *ptr,unsigned int size);
void fwif_color_od_table_17x17_transform(bool transType, unsigned char *pTableIn, unsigned int *pTableOut);
void drvif_color_od_table_seperate(unsigned int *pODtable, unsigned char tableType);

unsigned char fwif_color_set_linear_od_table(void);


#endif

void GetMemaddr_demur_od(void);

#endif /* #ifndef PANEL_API_API_H */
