/*
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Marius Groeger <mgroeger@sysgo.de>
 *
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Alex Zuepke <azu@sysgo.de>
 *
 * (C) Copyright 2002
 * Gary Jennejohn, DENX Software Engineering, <garyj@denx.de>
 *
 * (C) Copyright 2004
 * DAVE Srl
 * http://www.dave-tech.it
 * http://www.wawnet.biz
 * mailto:info@wawnet.biz
 *
 * (C) Copyright 2004 Texas Insturments
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <watchdog_api.h>
#include <asm/arch/io.h>

extern void CusApi_do_reset(void);

int do_reset(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	CusApi_do_reset();

	puts ("resetting ...\n");

	udelay (50000);				/* wait 50 ms */

	disable_interrupts();
	//reset_cpu(0);

	// trigger watchdog reset
#ifdef CONFIG_BSP_REALTEK

/* For RTD299S, WDOG clock default enable, so no need to turn on.*/
#if 0 // RTD299S_FIXME
	if ((rtd_inl(CRT_WDOG_DATA13_VADDR) & _BIT1) == 0x0) {
		puts ("enable WDOG clk ...\n");

		// disable watchdog clock/reset
		rtd_clearbits(CRT_WDOG_DATA13_VADDR, _BIT1);
		rtd_clearbits(CRT_WDOG_DATA13_VADDR, _BIT3);

		// enable watchdog clock/reset
		udelay(10);
		rtd_setbits(CRT_WDOG_DATA13_VADDR, _BIT3);
		udelay(10);
		rtd_setbits(CRT_WDOG_DATA13_VADDR, _BIT1);

		// default disable watchdog
		rtd_outl(RTD294X_MIS_TCWCR_reg, 0xA5);	// disable watchdog
		rtd_outl(RTD294X_MIS_TCWTR_reg, 0x1);	// clear watchdog counter
	}
#endif

	rtd_setbits(ISO_MISC_TCWCR_reg, _BIT31);	/*Immediate Wdog reset*/
	while(1)
		;

#endif
	/*NOTREACHED*/
	return 0;
}
