#include <common.h>
#include <command.h>
//#include <watchdog.h>
#include "watchdog_api.h"
//#include <io.h>

int enable_watchdog(unsigned int times)
{
	unsigned int mtime = 0x08000000/5*times;
	rtd_outl(ISO_MISC_TCWOV_reg, mtime);
	rtd_outl(ISO_MISC_TCWNMI_reg, 0x07ff0000);
	rtd_maskl(ISO_MISC_TCWCR_reg, ~0xFF, 0x00);
	return 0;
}

int disable_watchdog(void)
{
	rtd_maskl(ISO_MISC_TCWCR_reg, ~0xFF, 0xA5);
	return 0;
}

int do_switch_watchdog (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	ulong on_off = 0;
	char *status = NULL;
	unsigned int times = 5;
	if (argc == 1) // print usage
		return CMD_RET_USAGE;
	if (argc > 1)
	{
		status = argv[1];
		if(argc > 2)
		{
			times = simple_strtoul(argv[2], NULL, 16);
		}
		on_off = simple_strtoul(argv[1], NULL, 16);
		if(on_off)
		{
			//CMD_WATCHDOG_ENABLE();
			enable_watchdog(times);
			printf("watch dog enabled,timeout:%d second(s)...\n",times);
		}
		else
		{
			disable_watchdog();
			printf("watch dog disabled...\n");
		}
		if(!strcmp("on", status))
		{
			printf("Enable watchdog always.\n");
			setenv("wdt", status);
			saveenv();
		}
		else if(!strcmp("off", status)){
			printf("Disable watchdog always.\n");
			setenv("wdt", NULL);
			saveenv();
		}
	}
	return 0;
}

U_BOOT_CMD(
	wdt,	3,	1,	do_switch_watchdog,
	"watch dog enable/disable",
	"[0/1 [seconds]]"
	"wdt on: enable watchdog always.\n"
	"wdt off: disable watchdog always.\n"
	"wdt 1: enable watchdog once.\n"
);

