#include <common.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <drivers/i2c/rtk_g2c_lib.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <panel.h>
#include <asm/arch/panel_config_parameter.h>


#ifdef CONFIG_CUSTOM_SN_PANEL
#include <ppoverlay_reg.h>
extern int IsID_Match(void);
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);
extern void panel_set_spread_spectrum(UINT8  bEnable, UINT16 u16Percent, UINT32 ss_freq);
extern int boot_power_on_mode;
#endif

#ifdef CONFIG_CUSTOM_PQ_SELECT
#define MODEL_ENV_FILE_NAME "tmp/factory/Model_Env.xml"
extern int CusApi_env_readXmlFile(const char* pFileName, const char *pItemName, char *pParameter, size_t parameterLen);
#endif

#ifdef CONFIG_CUSTOM_SET_SERIAL_NUMBER
#define SERIAL_CODE         "serialNumber"
#define PRODUCT_CODE        "product_code"
#define FACTORY_SERIAL_NUMBER_FILE  "tmp/factory/serialNumber.xml"
#define TAKEOVER_SERIAL_NUMBER_FILE   "takeover/serialNumber.xml"

extern bool fsw_emmc_bootup;

void env_SetSerialNo(char *pParameter)
{
	int i;
	char convet_code[12] = {0};
	//char under_symbol = '_';
	char finalstr[32] = {0};
	char serialStr[12]={0};
	char defaultvalue[7] = {'0','0','0','0','0','0','0'};
	char* serialstr;
	for(i = 0; i < 12 ; i++)
	{
		if(i == 0)
			continue;
		else
		{
			if(pParameter[i] == '0')
				convet_code[i-1] = 'x';
			else if(pParameter[i] == '1')
				convet_code[i-1] = 'q';
			else if(pParameter[i] == '2')
				convet_code[i-1] = 'a';
			else if(pParameter[i] == '3')
				convet_code[i-1] = 'z';
			else if(pParameter[i] == '4')
				convet_code[i-1] = 'w';
			else if(pParameter[i] == '5')
				convet_code[i-1] = 'e';
			else if(pParameter[i] == '6')
				convet_code[i-1] = 's';
			else if(pParameter[i] == '7')
				convet_code[i-1] = 'd';
			else if(pParameter[i] == '8')
				convet_code[i-1] = 'c';
			else if(pParameter[i] == '9')
				convet_code[i-1] = 'v';
		}
	}

    //read serial number
	if(!CusApi_env_readXmlFile(FACTORY_SERIAL_NUMBER_FILE,SERIAL_CODE,serialStr,sizeof(serialStr)))
	{
		sprintf(finalstr, "%s%s", convet_code,serialStr);
	}
	else if(!CusApi_env_readXmlFile(TAKEOVER_SERIAL_NUMBER_FILE,SERIAL_CODE,serialStr,sizeof(serialStr)))
	{
		sprintf(finalstr, "%s%s", convet_code,serialStr);
	}
	else
	{
		sprintf(finalstr, "%s%s", convet_code,defaultvalue);
	}

    //setenv
		if (((serialstr = getenv("FINAL_SERIAL_NUMBER")) != NULL) && (strcmp(serialstr, finalstr) == 0))
			printf("the serial number is the same as before\n");
		else
		{
			setenv("FINAL_SERIAL_NUMBER", finalstr);
		}
}
#endif

bool CusApi_panel_interface_common(void)
{
#ifdef CONFIG_CUSTOM_SN_PANEL
	if(IsID_Match())
		return false;
	else
		return true;
#else
	return false;
#endif
}

void CusApi_panel_i2c_init(void)
{

}

void CusApi_panel_customized_setting(void)
{
#if 1
	UINT8 stren =0;
	UINT8 ssEn=0;
	UINT8 ssPercent=0;
	UINT32 ssFreq=0;
	UINT8 Pre_em_en=0;
	UINT8 Pre_em_level=0;
	#ifdef CONFIG_CUSTOM_SET_SERIAL_NUMBER
	char productStr[32]={0};
	char defaultvalue[9] = {'P','0','0','0','0','0','0','0','0'};
	#endif

	//printf("00 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//Pre-empahsis
	Pre_em_en =default_panel_parameter.snInfo[0].Pre_emphasis_On_Off;
	//Pre_em_en=1;
	rtd_part_outl(0xb8000D04, 30, 30, Pre_em_en); // LANE0
	rtd_part_outl(0xb8000D14, 30, 30, Pre_em_en); // LANE1
	rtd_part_outl(0xb8000D24, 30, 30, Pre_em_en); // LANE2
	rtd_part_outl(0xb8000D34, 30, 30, Pre_em_en); // LANE3
	rtd_part_outl(0xb8000D44, 30, 30, Pre_em_en); // LANE4
	rtd_part_outl(0xb8000D54, 30, 30, Pre_em_en); // LANE5
	rtd_part_outl(0xb8000D64, 30, 30, Pre_em_en); // LANE6
	rtd_part_outl(0xb8000D74, 30, 30, Pre_em_en); // LANE7

	//printf("01 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//driver strength
	stren=default_panel_parameter.snInfo[0].Drive_strength;

	//stren=4;
	printf("stren =%d\n",stren);
	
	rtd_part_outl(0xb8000D00, 7, 4, stren); // LANE0
	rtd_part_outl(0xb8000D10, 7, 4, stren); // LANE1
	rtd_part_outl(0xb8000D20, 7, 4, stren); // LANE2
	rtd_part_outl(0xb8000D30, 7, 4, stren); // LANE3
	rtd_part_outl(0xb8000D40, 7, 4, stren); // LANE4
	rtd_part_outl(0xb8000D50, 7, 4, stren); // LANE5
	rtd_part_outl(0xb8000D60, 7, 4, stren); // LANE6
	rtd_part_outl(0xb8000D70, 7, 4, stren); // LANE7

	//printf("02 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//level
	Pre_em_level =default_panel_parameter.snInfo[0].Pre_emphasis_level;

	//level shift 1~8
	Pre_em_level=Pre_em_level+1;
	//Pre_em_level=3;	
	if(Pre_em_level>=8)
		Pre_em_level=8;
		
	printf("Pre_em_en =%d Pre_em_level=%d\n",Pre_em_en,Pre_em_level);
	rtd_part_outl(0xb8000D00, 3, 0, Pre_em_level); // LANE0
	rtd_part_outl(0xb8000D10, 3, 0, Pre_em_level); // LANE1
	rtd_part_outl(0xb8000D20, 3, 0, Pre_em_level); // LANE2
	rtd_part_outl(0xb8000D30, 3, 0, Pre_em_level); // LANE3
	rtd_part_outl(0xb8000D40, 3, 0, Pre_em_level); // LANE4
	rtd_part_outl(0xb8000D50, 3, 0, Pre_em_level); // LANE5
	rtd_part_outl(0xb8000D60, 3, 0, Pre_em_level); // LANE6
	rtd_part_outl(0xb8000D70, 3, 0, Pre_em_level); // LANE7

	//printf("03 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//spread spectrum
	ssEn = default_panel_parameter.snInfo[0].Spread_spectrum_On_Off;
	ssPercent=default_panel_parameter.snInfo[0].SpreadPermillage*2;
	ssFreq = default_panel_parameter.snInfo[0].SpreadFreq;
	//test
	//ssEn=1;
	//ssPercent=10;
	//ssFreq=60000;
	printf("ssEn =%d ssPercent =%d ssFreq=%d\n",ssEn,ssPercent,ssFreq);
	panel_set_spread_spectrum(ssEn,ssPercent,ssFreq);

	ppoverlay_dv_length_RBUS dv_length_reg;
	ppoverlay_dh_width_RBUS dh_width_reg;
	//ppoverlay_memcdtg_control_RBUS memcdtg_control_reg;
	ppoverlay_memcdtg_dv_total_RBUS memcdtg_dv_total_reg;
	ppoverlay_memcdtg_dh_total_RBUS memcdtg_dh_total_reg;
	ppoverlay_memcdtg_dv_den_start_end_RBUS memcdtg_dv_den_start_end_reg;
	ppoverlay_memcdtg_dh_den_start_end_RBUS memcdtg_dh_den_start_end_reg;
	//ppoverlay_memc_mux_ctrl_RBUS memc_mux_ctrl_reg;

	ppoverlay_main_active_h_start_end_RBUS main_active_h_start_end_reg;
	//ppoverlay_main_background_v_start_end_RBUS main_background_v_start_end_reg;
	ppoverlay_main_active_v_start_end_RBUS main_active_v_start_end_reg;

	dv_length_reg.regValue = rtd_inl(PPOVERLAY_DV_Length_reg);
	dh_width_reg.regValue = rtd_inl(PPOVERLAY_DH_Width_reg);
	
	memcdtg_dv_total_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_TOTAL_reg);
	memcdtg_dh_total_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_TOTAL_reg);
	memcdtg_dv_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_DEN_Start_End_reg);
	memcdtg_dh_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_DEN_Start_End_reg);

	main_active_h_start_end_reg.regValue =rtd_inl(PPOVERLAY_MAIN_Active_H_Start_End_reg);
	main_active_v_start_end_reg.regValue =rtd_inl(PPOVERLAY_MAIN_Active_V_Start_End_reg);

	printf("Htotal(%x = %x) %d\n", PPOVERLAY_memcdtg_DH_TOTAL_reg, memcdtg_dh_total_reg.regValue,memcdtg_dh_total_reg.regValue & 0x00001FFF);
	printf("Hactive(%x = %x) %d\n",PPOVERLAY_MAIN_Active_H_Start_End_reg,main_active_h_start_end_reg.regValue,main_active_h_start_end_reg.regValue & 0x00000FFF);
	printf("H_DEN start(%x = %x) %d\n", PPOVERLAY_memcdtg_DH_DEN_Start_End_reg, memcdtg_dh_den_start_end_reg.regValue,memcdtg_dh_den_start_end_reg.regValue>>16);
	printf("HPulse(%x = %x) %d\n", PPOVERLAY_DH_Width_reg, dh_width_reg.regValue,dh_width_reg.regValue);
	
	printf("Vtotal(%x = %x) %d\n", PPOVERLAY_memcdtg_DV_TOTAL_reg, memcdtg_dv_total_reg.regValue,memcdtg_dv_total_reg.regValue&0x00001FFF);
	printf("Vactive(%x = %x) %d\n",PPOVERLAY_MAIN_Active_V_Start_End_reg,main_active_v_start_end_reg.regValue,main_active_v_start_end_reg.regValue&0x00000FFF);
	printf("V_DEN start(%x = %x) %d\n", PPOVERLAY_memcdtg_DV_DEN_Start_End_reg, memcdtg_dv_den_start_end_reg.regValue,memcdtg_dv_den_start_end_reg.regValue>>16);
	printf("VPulse(%x = %x) %d\n", PPOVERLAY_DV_Length_reg, dv_length_reg.regValue,dv_length_reg.regValue);
	
	//sn power seq spec
	if (boot_power_on_mode == POWER_OFF){
		//IO_Set(PIN_DEMOD_RST_STBY, 0);	
	}else{
		IO_Set(PIN_USB_EN_P1, 1);
		IO_Set(PIN_USB_EN_P0, 1);
	}
	
	//IO_Set(PIN_WIFI_HOST_RESET, 1);	
	//mdelay(10);
	IO_Set(PIN_WIFI_HOST_RESET, 0);
	mdelay(100);//CN request delay
       if(boot_power_on_mode != POWER_OFF)
	    IO_Set(PIN_WIFI_HOST_RESET, 1);

#ifdef CONFIG_CUSTOM_SET_SERIAL_NUMBER
	//Get data from Model env and serialNumber xml file to set serial number
	if(fsw_emmc_bootup)
		return;
    if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME,PRODUCT_CODE,productStr,sizeof(productStr)))
		env_SetSerialNo(productStr);
	else
		env_SetSerialNo(defaultvalue);
#endif
#endif	
	
}
