#include <common.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include "cus_common.h"

void Check_Update_EthAddr(void)
{
	char *s;
	
	if(check_mac(cus_bootparam.macaddress) == 0)
	{
		s = getenv("ethaddr");	
		printf("\nenv mac: %s\n",s);
		printf("\nbootparam mac: %s\n",cus_bootparam.macaddress);
		
		if(strcmp(s,cus_bootparam.macaddress) != 0)
		{
			if (setenv("ethaddr", cus_bootparam.macaddress) == 0) 
			{
				char cmd[128];
				printf("\033[1;31m setenv ethaddr success\033[m\n");
				memset(cmd, 0, sizeof(cmd));
				sprintf(cmd, "saveenv");
				if(run_command(cmd, 0)!= 0)
				{
					printf("\033[1;31m [WARN] %s:saveenv failed.\033[m\n", __FUNCTION__);
				}
			}
			else
				printf("\033[1;31m setenv ethaddr fail\033[m\n");
		}
	}
}

void CusApi_env_relocate(void)
{
	Check_Update_EthAddr();
}
