#ifndef __RTK_PWM_LIB_H__
#define __RTK_PWM_LIB_H__

#if defined(CONFIG_RTD289X) || defined(CONFIG_RTD284X) || defined(CONFIG_RTD287X) || defined(CONFIG_RTD285X)
#include <sys_reg_reg.h>
#include <stb_reg.h>
#else
#include <rbus/rbusCRTReg.h>
#include <rbus/rbusStandbyReg.h>
#endif


#if defined(CONFIG_RTD289X) || defined(CONFIG_RTD284X)
#define ISO_PWM_MAX	2
#define MISC_PWM_MAX	8
#else
#define ISO_PWM_MAX	1
#define MISC_PWM_MAX	1
#endif


#define N_MAX  (4096)
#define M_MAX  (3)
#define CONFIG_CPU_XTAL_FREQ (27000000)
#define CONFIG_CPU_XTAL_NS   (37)    /*1/27000000*/
#define CONFIG_VSYNC_FREQ    (60)
#define ABS(x, y)    ((x) > (y) ? ((x)-(y)) : ((y)-(x)))
#define CONFIG_VSYNC_FREQ    (60)

typedef struct RTK_PWM_INFO {
	int m_index;
	int m_run;
	int m_duty;
	int m_freq;
	int m_adpt_en;
	int m_freq48n;
	int m_freq50n;
	int m_freq60n;
	int m_vsync;
	int m_pos;
} RTK_PWM_INFO_T;


struct rtk_pwm_reg_map_t {
	unsigned long CTRL;
	unsigned long TIMING_CTRL;
	unsigned long DUTY_SET;
};
typedef struct rtk_pwm_reg_map_t rtk_pwm_reg_map;

#define  ISO_MIS_PWM_DB_CTRL_VADDR      (0xb8061280)
#define  ISO_MIS_PWM0_CTRL_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x4)
#define  ISO_MIS_PWM0_TIMING_CTRL_VADDR     (ISO_MIS_PWM_DB_CTRL_VADDR + 0x8)
#define  ISO_MIS_PWM0_DUTY_SET_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0xC)
#define  ISO_MIS_PWM1_CTRL_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x10)
#define  ISO_MIS_PWM1_TIMING_CTRL_VADDR     (ISO_MIS_PWM_DB_CTRL_VADDR + 0x14)
#define  ISO_MIS_PWM1_DUTY_SET_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x18)
#define  ISO_MIS_PWM2_CTRL_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x1C)
#define  ISO_MIS_PWM2_TIMING_CTRL_VADDR     (ISO_MIS_PWM_DB_CTRL_VADDR + 0x20)
#define  ISO_MIS_PWM2_DUTY_SET_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x24)
#define  ISO_MIS_PWM3_CTRL_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x28)
#define  ISO_MIS_PWM3_TIMING_CTRL_VADDR     (ISO_MIS_PWM_DB_CTRL_VADDR + 0x2C)
#define  ISO_MIS_PWM3_DUTY_SET_VADDR        (ISO_MIS_PWM_DB_CTRL_VADDR + 0x30)

#define  MIS_PWM_DB_CTRL_VADDR      (0xb801bc80)
#define  MIS_PWM0_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x4)
#define  MIS_PWM0_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x8)
#define  MIS_PWM0_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0xC)
#define  MIS_PWM1_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x10)
#define  MIS_PWM1_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x14)
#define  MIS_PWM1_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x18)
#define  MIS_PWM2_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x1C)
#define  MIS_PWM2_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x20)
#define  MIS_PWM2_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x24)
#define  MIS_PWM3_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x28)
#define  MIS_PWM3_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x2C)
#define  MIS_PWM3_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x30)
#define  MIS_PWM4_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x34)
#define  MIS_PWM4_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x38)
#define  MIS_PWM4_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x3C)
#define  MIS_PWM5_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x40)
#define  MIS_PWM5_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x44)
#define  MIS_PWM5_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x48)
#define  MIS_PWM6_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x4C)
#define  MIS_PWM6_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x50)
#define  MIS_PWM6_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x54)
#define  MIS_PWM7_CTRL_VADDR        (MIS_PWM_DB_CTRL_VADDR + 0x58)
#define  MIS_PWM7_TIMING_CTRL_VADDR (MIS_PWM_DB_CTRL_VADDR + 0x5C)
#define  MIS_PWM7_DUTY_SET_VADDR    (MIS_PWM_DB_CTRL_VADDR + 0x60)

struct rtk_pwm_phy_t {
	const rtk_pwm_reg_map *p_reg_map;
};

typedef struct rtk_pwm_phy_t rtk_pwm_phy;


struct rtk_pwm_pin_t {
	const char* pcb_name;
	rtk_pwm_phy pwm_phy;
	int index;
};
typedef struct rtk_pwm_pin_t rtk_pwm_pin;

static const rtk_pwm_reg_map iso_pwm0_reg = {
	.CTRL = ISO_MIS_PWM0_CTRL_VADDR,
	.TIMING_CTRL = ISO_MIS_PWM0_TIMING_CTRL_VADDR,
	.DUTY_SET = ISO_MIS_PWM0_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map iso_pwm1_reg = {
	.CTRL = ISO_MIS_PWM1_CTRL_VADDR,
	.TIMING_CTRL = ISO_MIS_PWM1_TIMING_CTRL_VADDR,
	.DUTY_SET = ISO_MIS_PWM1_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map iso_pwm2_reg = {
	.CTRL = ISO_MIS_PWM2_CTRL_VADDR,
	.TIMING_CTRL = ISO_MIS_PWM2_TIMING_CTRL_VADDR,
	.DUTY_SET = ISO_MIS_PWM2_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map iso_pwm3_reg = {
	.CTRL = ISO_MIS_PWM3_CTRL_VADDR,
	.TIMING_CTRL = ISO_MIS_PWM3_TIMING_CTRL_VADDR,
	.DUTY_SET = ISO_MIS_PWM3_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm0_reg = {
	.CTRL = MIS_PWM0_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM0_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM0_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm1_reg = {
	.CTRL = MIS_PWM1_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM1_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM1_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm2_reg = {
	.CTRL = MIS_PWM2_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM2_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM2_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm3_reg = {
	.CTRL = MIS_PWM3_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM3_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM3_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm4_reg = {
	.CTRL = MIS_PWM4_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM4_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM4_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm5_reg = {
	.CTRL = MIS_PWM5_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM5_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM5_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm6_reg = {
	.CTRL = MIS_PWM6_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM6_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM6_DUTY_SET_VADDR,
};

static const rtk_pwm_reg_map mis_pwm7_reg = {
	.CTRL = MIS_PWM7_CTRL_VADDR,
	.TIMING_CTRL = MIS_PWM7_TIMING_CTRL_VADDR,
	.DUTY_SET = MIS_PWM7_DUTY_SET_VADDR,
};

#if 0
static rtk_pwm_phy pwm_iso_phy[] = {
	{&iso_pwm0_reg},
	{&iso_pwm1_reg},
	{&iso_pwm2_reg},
	{&iso_pwm3_reg},
};

static rtk_pwm_phy pwm_mis_phy[] = {
	{&mis_pwm0_reg},
	{&mis_pwm1_reg},
	{&mis_pwm2_reg},
	{&mis_pwm3_reg},
	{&mis_pwm4_reg},
	{&mis_pwm5_reg},
	{&mis_pwm6_reg},
	{&mis_pwm7_reg},
};
#endif

#define pwm_info_print(fmt,args...)		printf(fmt,## args)
#define pwm_debug_print(fmt,args...)		//printf(fmt,## args)

#if 0
static rtk_pwm_pin g_pwm_phy_avlb[] = {
	{"PIN_ISO_PWM_DIM1", {&iso_pwm0_reg}, -1},
	{"PIN_ISO_PWM_DIM2", {&iso_pwm1_reg}, -1},
	{"PIN_ISO_PWM_DIM3", {&iso_pwm2_reg}, -1},
	{"PIN_ISO_PWM_DIM4", {&iso_pwm3_reg}, -1},
	{"PIN_PWM_DIM1", {&mis_pwm0_reg}, -1},
	{"PIN_PWM_DIM2", {&mis_pwm1_reg}, -1},
	{"PIN_PWM_DIM3", {&mis_pwm2_reg}, -1},
	{"PIN_PWM_DIM4", {&mis_pwm3_reg}, -1},
	{"PIN_PWM_DIM5", {&mis_pwm4_reg}, -1},
	{"PIN_PWM_DIM6", {&mis_pwm5_reg}, -1},
	{"PIN_PWM_DIM7", {&mis_pwm6_reg}, -1},
	{"PIN_PWM_DIM8", {&mis_pwm7_reg}, -1},
};

#define RTK_PWM_CANDIDATE_CNT  (sizeof(g_pwm_phy_avlb)/sizeof(g_pwm_phy_avlb[0]))
#endif

/** these function code in driver/pwm/pwm.c **/
extern void rtk_hw_get_divider(int pwm_freq_hz, int duty_max,
				unsigned short *M_best, unsigned short *N_best);
extern int get_pwm_frequency(char type, int index);
extern int set_pwm_frequency(char type, int index, int freq);

extern int get_pwm_duty(char type, int index);
extern int set_pwm_duty(char type, int index, int duty);
extern int set_pwm_duty_full(int duty);

extern int get_pwm_enable(char type, int index);
extern int set_pwm_enable(char type, int index, int enable);

extern int get_pwm_sync(char type, int index);
extern int set_pwm_sync(char type, int index, int rtk_vsync);
/** these function code in driver/pwm/pwm.c **/


int rtk_pwm_init(void);
int rtk_pwm_set(RTK_PWM_INFO_T* param);
void rtk_pwm_test(void);

#endif
