#include <common.h>
#include <command.h>
#include <io.h>
#include <common/rtk_menu.h>

rtk_menu_state rtk_state;

void rtk_prepare_go_ahead(rtk_menu_state * p)
{
    if(p->level > MENU_LEVEL_MAX)
        return;

    snprintf(p->path[rtk_state.level],MENU_NAME_LEN,p->menu[0].name);
    p->level++;
}

void rtk_prepare_go_back(rtk_menu_state * p)
{
    if(p->level > 0)
    {
        p->level--;
    }
}

void rtk_show_menu(rtk_setmenu * p)
{
    int i = 0;

    printf("%s\n", p[0].desc);//print title
    i = 1;
    while(p[i].name != NULL)//print items
    {
        printf("[%d] %-16s : %s\n", i, p[i].name, p[i].desc);
        i++;
    }
}

void rtk_show_now_path(rtk_menu_state * p)
{
    int i = 0;
    printf(FYELLOW_START);
    for(i = 0;i < p->level;++i)
    {
        if(i != 0)
        {
            printf(" -> ");
        }
        else
        {
            printf("menu path:");
        }
        printf("%s",p->path[i]);
    }
    printf("\n" FCOLOR_END);
}

int rtk_get_menu_len(rtk_setmenu * p)
{
    int i = 0;
    while(p[i].name != NULL)//print items
    {
        i++;
    }

    return i-1;//don't count p[0](p[0] is a title item)
}

void rtk_menu_wait(rtk_menu_state* p)
{
    int index = 0;
    char buf[64] = {0};
    int len;

    rtk_show_now_path(p);
    rtk_show_menu(p->menu);
    len = rtk_get_menu_len(p->menu);

    index = 0;
    while((index <= 0) || (index > len))
    {
        printf("\nP:PREVIOUS\ninput choice:");
        gets(buf);
        //dump_buffer_data(buf,4);
        if(buf[0] == 'P'||buf[0] == 'p') //if use P, go back
        {
            printf("\n");
            rtk_go_up_menu(p);
            break;
        }
        index = simple_strtoul(buf, NULL, 16);
        printf("\n");
        //printf("\nget choice:%d\n", index);
    }

    if((p->menu !=NULL)&&(p->menu[index].func != NULL))
    {
        (*(p->menu[index].func))();
    }
}

int rtk_go_up_menu(rtk_menu_state* p)
{
    rtk_prepare_go_back(p);
    p->menu = p->menu[0].father;

    return 0;
}

int rtk_go_menu_exit(void)
{
    printf("******** menu exit! ********\n");
    return 0;
}



