#include <linux/string.h>
//#include <platform_lib/board/pcb_mgr.h>
//#include <platform_lib/board/pcb.h>
#include <common.h>
#include <command.h>
#include <malloc.h>
#include <linux/compiler.h>
#include <asm/io.h>
#include "ad82088.h"
#include <drivers/i2c/rtk_i2c_lib.h>

//*************************************************************
// PUBLIC FUNCTIONS
//*************************************************************
#define END_FLAG 	(0xff)
#define AMP_DEBUG 	(1)

typedef struct
{
    unsigned char bAddr;
    unsigned char bArray;
}AD82088_REG;

static AD82088_REG AD82088_InitTbl[] = 
{
 {0x1a, 0x12}, //software reset
 {0x1a, 0x32},//normal operation
 {0x02, 0x1f},//mute all channel
 {0x03, 0x18},//Master_volume_control                     
 {0x04, 0x18},//Channel_1_volume_control
 {0x05, 0x18},//Channel_2_volume_control
 {0x0c, 0x18},//State_Control_4     //
 {0x1b, 0x00},//State_Control_6   
 {0x02, 0x00}, //unmute alll channel
 {END_FLAG ,0x00},//END
};

void ad82088_func(int bus_id, unsigned short addr)
{
    unsigned char data[2];
    unsigned char regaddr;
    unsigned char index;
    for(index = 0; ; index ++)
    {
        regaddr = AD82088_InitTbl[index].bAddr;
        data[0] = AD82088_InitTbl[index].bAddr;
        data[1] = AD82088_InitTbl[index].bArray;
        if(regaddr == END_FLAG)
        {
            break;
        }

#if AMP_DEBUG
        printf("\nwrite addr:0x%x----data[0]=0x%x----data[1]=0x%x\n",regaddr,data[0],data[1]);
#endif
        if (I2C_Write_EX(AMP_I2C, addr ,  2, data ) < 0)
            printf("program AD82088 failed\n");

#if AMP_DEBUG
        unsigned char readArray[2] = {0,0};
        if (I2C_Read_EX(AMP_I2C, addr , 1,  &regaddr, 2, readArray)!= S_OK)
        {
            printf("\n i2c read fail \n"  );
        }
        printf("\nread addr:0x%x----data[0]=0x%x----data[1]=0x%x\n",regaddr,readArray[0],readArray[1]);
#endif

    }
}

