#include <linux/string.h>
#include <common.h>
#include <command.h>
#include <malloc.h>
#include <linux/compiler.h>
#include <asm/io.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <drivers/amp/rtk_amp_interface.h>

#if defined(CONFIG_AMP_RT9119)
#include "RT9119/rt9119.h"
#endif

#if defined(CONFIG_REALTEK_AMP_ACL1310)
#include "ALC1310/alc1310.h"
#endif

#if defined(CONFIG_REALTEK_AMP_AD82010)
#include "AD82010/ad82010.h"
#endif

#if defined(CONFIG_REALTEK_AMP_TAS5751)
#include "TAS5751/tas5751.h"
#endif

#if defined(CONFIG_REALTEK_AMP_AD82088)
#include "AD82088/ad82088.h"
#endif

#if defined(CONFIG_REALTEK_AMP_ALC1311)
#include "ALC1311/alc1311.h"
#endif

#if defined(CONFIG_REALTEK_AMP_TAS5707)
#include "TAS5707/tas5707.h"
#endif

#if defined(CONFIG_REALTEK_AMP_TAS5711)
#include "TAS5711/tas5711.h"
#endif

#define AMP_BOOT_PARAM "amp_select"
#define AMP_BOOT_VALUE "amp_select_value"


static char *current_sel = NULL;
static char *slave_addr  = NULL;

struct amp_controller rtk_amp;

extern void rtk_amp_ops_set(int sel);
extern void alc1310_func(int bus_id, unsigned short addr);



void AudioAmp_InitAudioOut2I2S_1st(void)
{
    int select = 0;
    slave_addr = getenv(AMP_BOOT_VALUE);
    current_sel = getenv(AMP_BOOT_PARAM);

    if(current_sel != NULL)
        select = simple_strtoul(current_sel, NULL, 10);

    if(slave_addr != NULL)
        rtk_amp.slave_addr = simple_strtoul(slave_addr, NULL, 16);

    I2C_Init();
    I2C_SetSpeed( AMP_I2C , 400 );

    if(current_sel == NULL){
        rtk_amp.slave_addr = getAmpI2cAddress(0);
        setAmpInitFunc(0 , &rtk_amp);
        printf("\n AMP select is NULL \n");
        printf("\n AMP I2C Port_Id  =  %d sel:0x%08X Slave_addr:0x%X\n", AMP_I2C, select,rtk_amp.slave_addr);
    }
    else{
        setAmpInitFunc(select , &rtk_amp);
        printf("\n AMP I2C Port_Id  =  %d sel:0x%08X Slave_addr:0x%X\n", AMP_I2C, select,rtk_amp.slave_addr );
    }
    printf("rtk_amp_i2c_init done\n");
}

void AudioAmp_InitAudioOut2I2S_2nd(void)
{
    AudioAmp_InitAudioOut2I2S_1st();

    current_sel = getenv(AMP_BOOT_PARAM);

    if(current_sel == NULL)
    {
        rtk_amp.ops(AMP_I2C,getAmpI2cAddress(0));
    }
    else
    {
        rtk_amp.ops(AMP_I2C,rtk_amp.slave_addr);
    }

    printf("rtk_amp_init done\n");
}

