#include <drivers/gpio/rtk_gpio.h>

#ifndef __ROKU_DRVGPIO_H__
#define __ROKU_DRVGPIO_H__


/*
 * Typical gpio definitions
 */
#define PAD_TS0_D0 10
#define PAD_TS0_D1 11
#define PAD_TS0_D2 12
#define PAD_TS0_D3 13
#define PAD_TS0_D4 14
#define PAD_TS0_D5 15
#define PAD_TS0_D6 16
#define PAD_TS0_D7 16
#define PAD_TS0_CLK 17
#define PAD_TS0_VLD 18

// Gpio driver initialization.
void PAL_Gpio_Init(void);

// Sets a gpio high
void PAL_Gpio_Set_High(int gpio);

// Sets a gpio low
void PAL_Gpio_Set_Low(int gpio);

// Configures a gpio as input
void PAL_Gpio_Set_Input(int gpio);

// Configures a gpio as Output
void PAL_Gpio_Set_Output(int gpio);

// Reports the current configuration(input or output of a given gpio
int PAL_Gpio_Get_InOut(int gpio);

// Reports the state (high or low) of a given gpio
int PAL_Gpio_Get_Level(int gpio);

int getGPIOgroup(int gpio_num);

int getGPIOnumber(int gpio_num);

int rt_gpio_output_roku(int gpioNum, int value, RT_GPIO_TYPE rtGpioType,int type);

int rt_gpio_input_roku(int gpioNum, RT_GPIO_TYPE rtGpioType,int type);

int rt_gpio_getlevel_roku(int gpioNum, RT_GPIO_TYPE rtGpioType);

#endif
