/**************************************************************
// Spec Version                  : 1.4
// Parser Version                : DVR_Parser_6.11(120105)
// CModelGen Version             : 5.1 2012.01.05
// Naming Rule                   :  Register_Name
// Naming Rule                   : Module_Register_Name_reg
// Parse Option                  : Only Parse _op1
// Parse Address Region          : All Address Region
// Decode bit number             : 12 bits
// Firmware Header Generate Date : 2013/11/13 14:18:21
***************************************************************/


#ifndef __RTK_MD_REG_H__
#define __RTK_MD_REG_H__

#define BIT(x)                      (1 << (x))
#define MD_CMD_BUF          (4096 * sizeof(uint32_t))
#define MD_ONE_CMD_LEN  (4 * sizeof(uint32_t))


#define MD_SMQ_CNTL_reg                                              0xB800B000
#define MD_SMQ_INT_STATUS_reg                                   0xB800B004
#define MD_SMQ_INT_ENABLE_reg                                    0xB800B008
#define MD_SMQBASE_reg                                                 0xB800B00C
#define MD_SMQLIMIT_reg                                                0xB800B010
#define MD_SMQRDPTR_reg                                               0xB800B014
#define MD_SMQWRPTR_reg                                              0xB800B018
#define MD_SMQFIFOSTATE_reg                                         0xB800B01C
#define MD_SMQ_INSTCNT_reg                                           0xB800B020
#define MD_VMQ_CNTL_reg                                                0xB800B030
#define MD_VMQ_INT_STATUS_reg                                     0xB800B034
#define MD_VMQ_INT_ENABLE_reg                                      0xB800B038
#define MD_VMQBASE_reg                                                   0xB800B03C
#define MD_VMQLIMIT_reg                                                  0xB800B040
#define MD_VMQRDPTR_reg                                                0xB800B044
#define MD_VMQWRPTR_reg                                                0xB800B048
#define MD_VMQFIFOSTATE_reg                                          0xB800B04C
#define MD_VMQ_INSTCNT_reg                                           0xB800B050
#define MD_KMQ_CNTL_reg                                                 0xB800B060
#define MD_KMQ_INT_STATUS_reg                                      0xB800B064
#define MD_KMQ_INT_ENABLE_reg                                       0xB800B068
#define MD_KMQBASE_reg                                                     0xB800B06C
#define MD_KMQLIMIT_reg                                                    0xB800B070
#define MD_KMQRDPTR_reg                                                  0xB800B074
#define MD_KMQWRPTR_reg                                                 0xB800B078
#define MD_KMQFIFOSTATE_reg                                            0xB800B07C
#define MD_KMQ_INSTCNT_reg                                              0xB800B080
#define MD_DBG_reg                                                               0xB800B0D0
#define MD_FDMA_DDR_SADDR_reg                                        0xB800B088
#define MD_FDMA_FL_SADDR_reg                                          0xB800B08C
#define MD_FDMA_CTRL2_reg                                                 0xB800B090
#define MD_FDMA_CTRL1_reg                                                  0xB800B094
#define MD_FDMA_DDR_SADDR_K_reg                                    0xB800B190
#define MD_FDMA_FL_SADDR_K_reg                                        0xB800B194
#define MD_FDMA_CTRL2_K_reg                                              0xB800B198
#define MD_FDMA_CTRL1_K_reg                                              0xB800B19C
#define MD_POWER_reg                                                           0xB800B128
#define MD_DUMMY1_reg                                                         0xB800B09C
#define MD_DUMMY2_reg                                                         0xB800B0A0
#define MD_REG_MODE_reg                                                     0xB800B144
#define MD_REG_CTRL_reg                                                      0xB800B148
#define MD_REG_CMD1_reg                                                      0xB800B14C
#define MD_REG_CMD2_reg                                                       0xB800B150
#define MD_REG_CMD3_reg                                                      0xB800B154
#define MD_REG_CMD4_reg                                                       0xB800B158
#define MD_W_CRC_CTRL_reg                                                   0xB800B15C
#define MD_W_CRC_MASK1_reg                                                0xB800B160
#define MD_W_CRC_MASK2_reg                                                0xB800B164
#define MD_W_CRC_RESULT_reg                                              0xB800B168
#define MD_R_CRC_CTRL_reg                                                    0xB800B16C
#define MD_R_CRC_MASK1_reg                                                 0xB800B170
#define MD_R_CRC_MASK2_reg                                                  0xB800B174
#define MD_DES_CRC_reg                                                          0xB800B178
#define MD_R_CRC_RESULT_reg                                                0xB800B17C
#define MD_CRC_STATUS_reg                                                    0xB800B180
#define MD_REG_CMD5_reg                                                       0xB800B184
#define MD_MULTI_REQ_reg                                                      0xB800B230


#define GET_MD_SMQ_CNTL()                                                  rtd_inl(MD_SMQ_CNTL_reg)                                           
#define GET_MD_SMQ_INT_STATUS()                                       rtd_inl(MD_SMQ_INT_STATUS_reg)
#define GET_MD_SMQ_INT_ENABLE()                                       rtd_inl(MD_SMQ_INT_ENABLE_reg)
#define GET_MD_SMQBASE()                                                    rtd_inl(MD_SMQBASE_reg)
#define GET_MD_SMQLIMIT()                                                   rtd_inl(MD_SMQLIMIT_reg)
#define GET_MD_SMQRDPTR()                                                 rtd_inl(MD_SMQRDPTR_reg)
#define GET_MD_SMQWRPTR()                                                 rtd_inl(MD_SMQWRPTR_reg)
#define GET_MD_SMQFIFOSTATE()                                           rtd_inl(MD_SMQFIFOSTATE_reg)
#define GET_MD_SMQ_INSTCNT()                                            rtd_inl(MD_SMQ_INSTCNT_reg)
#define GET_MD_DUMMY1()                                                     rtd_inl(MD_DUMMY1_reg)
#define GET_MD_MULTI_REQ()                                                 rtd_inl(MD_MULTI_REQ_reg)
#define GET_MD_REG_MODE()                                                  rtd_inl(MD_REG_MODE_reg)
#define GET_MD_REG_CTRL()                                                   rtd_inl(MD_REG_CTRL_reg)
#define GET_MD_REG_CMD1()                                                  rtd_inl(MD_REG_CMD1_reg)
#define GET_MD_REG_CMD2()                                                  rtd_inl(MD_REG_CMD2_reg)
#define GET_MD_REG_CMD3()                                                  rtd_inl(MD_REG_CMD3_reg)
#define GET_MD_REG_CMD4()                                                  rtd_inl(MD_REG_CMD4_reg)
#define GET_MD_W_CRC_CTRL()                                              rtd_inl(MD_W_CRC_CTRL_reg)
#define GET_MD_W_CRC_MASK1()                                            rtd_inl(MD_W_CRC_MASK1_reg)
#define GET_MD_W_CRC_MASK2()                                            rtd_inl(MD_W_CRC_MASK2_reg)
#define GET_MD_W_CRC_RESULT()                                          rtd_inl(MD_W_CRC_RESULT_reg)
#define GET_MD_R_CRC_CTRL()                                               rtd_inl(MD_R_CRC_CTRL_reg)
#define GET_MD_R_CRC_MASK1()                                             rtd_inl(MD_R_CRC_MASK1_reg)
#define GET_MD_R_CRC_MASK2()                                             rtd_inl(MD_R_CRC_MASK2_reg)
#define GET_MD_DES_CRC()                                                     rtd_inl(MD_DES_CRC_reg)
#define GET_MD_R_CRC_RESULT()                                            rtd_inl(MD_R_CRC_RESULT_reg)





#define SET_MD_SMQ_CNTL(val)                                               rtd_outl(MD_SMQ_CNTL_reg, val)                                           
#define SET_MD_SMQ_INT_STATUS(val)                                    rtd_outl(MD_SMQ_INT_STATUS_reg, val)
#define SET_MD_SMQ_INT_ENABLE(val)                                    rtd_outl(MD_SMQ_INT_ENABLE_reg, val)
#define SET_MD_SMQBASE(val)                                                  rtd_outl(MD_SMQBASE_reg, val)
#define SET_MD_SMQLIMIT(val)                                                 rtd_outl(MD_SMQLIMIT_reg, val)
#define SET_MD_SMQRDPTR(val)                                               rtd_outl(MD_SMQRDPTR_reg, val)
#define SET_MD_SMQWRPTR(val)                                               rtd_outl(MD_SMQWRPTR_reg, val)
#define SET_MD_SMQFIFOSTATE(val)                                         rtd_outl(MD_SMQFIFOSTATE_reg, val)
#define SET_MD_SMQ_INSTCNT(val)                                          rtd_outl(MD_SMQ_INSTCNT_reg, val)
#define SET_MD_DUMMY1(val)                                                   rtd_outl(MD_DUMMY1_reg, val)
#define SET_MD_MULTI_REQ(val)                                               rtd_outl(MD_MULTI_REQ_reg, val)
#define SET_MD_REG_MODE(val)                                                rtd_outl(MD_REG_MODE_reg, val)
#define SET_MD_REG_CTRL(val)                                                   rtd_outl(MD_REG_CTRL_reg, val)
#define SET_MD_REG_CMD1(val)                                                  rtd_outl(MD_REG_CMD1_reg, val)
#define SET_MD_REG_CMD2(val)                                                  rtd_outl(MD_REG_CMD2_reg, val)
#define SET_MD_REG_CMD3(val)                                                  rtd_outl(MD_REG_CMD3_reg, val)
#define SET_MD_REG_CMD4(val)                                                  rtd_outl(MD_REG_CMD4_reg, val)
#define SET_MD_W_CRC_CTRL(val)                                              rtd_outl(MD_W_CRC_CTRL_reg, val)
#define SET_MD_W_CRC_MASK1(val)                                            rtd_outl(MD_W_CRC_MASK1_reg, val)
#define SET_MD_W_CRC_MASK2(val)                                            rtd_outl(MD_W_CRC_MASK2_reg, val)
#define SET_MD_W_CRC_RESULT(val)                                          rtd_outl(MD_W_CRC_RESULT_reg, val)
#define SET_MD_R_CRC_CTRL(val)                                               rtd_outl(MD_R_CRC_CTRL_reg, val)
#define SET_MD_R_CRC_MASK1(val)                                             rtd_outl(MD_R_CRC_MASK1_reg, val)
#define SET_MD_R_CRC_MASK2(val)                                             rtd_outl(MD_R_CRC_MASK2_reg, val)
#define SET_MD_DES_CRC(val)                                                          rtd_outl(MD_DES_CRC_reg, val)
#define SET_MD_R_CRC_RESULT(val)                                                rtd_outl(MD_R_CRC_RESULT_reg, val)


#define MD_SMQ_IDLE_MASK                                                  0x00000008
#define MD_SMQ_IDLE_SHIFT                                                  3
#define GET_MD_SMQ_IDLE()                                                   ((GET_MD_SMQ_CNTL() & MD_SMQ_IDLE_MASK) >> MD_SMQ_IDLE_SHIFT)
         
#define MD_SMQ_INST_CNT_MASK                                           (0x0000FFFF)
#define MD_SMQ_INST_CNT_SHIFT                                           (0)
#define GET_MD_SMQ_INST_CNT()                                           ((GET_MD_SMQ_INSTCNT() & MD_SMQ_INST_CNT_MASK) >> MD_SMQ_INST_CNT_SHIFT)

#define MD_MULTI_REQ_EN_MASK                                           0x00000001 
#define MD_MULTI_REQ_EN_SHIFT                                           0
#define GET_MD_MULTI_REQ_EN()                                           ((GET_MD_MULTI_REQ() & MD_MULTI_REQ_EN_MASK) >> MD_MULTI_REQ_EN_SHIFT)
#define MD_MULTI_REQ_EN(x)                                                 (((x) << MD_MULTI_REQ_EN_SHIFT) & MD_MULTI_REQ_EN_MASK)

#define MD_REG_POLL_MASK                                                   0x0000ffff
#define MD_REG_POLL_SHIFT                                                   0 
#define GET_MD_REG_POLL()                                                   ((GET_MD_REG_CTRL() & MD_REG_POLL_MASK) >> MD_REG_POLL_SHIFT)
#define MD_REG_POLL(x)                                                         (((x) << MD_REG_POLL_SHIFT) & MD_REG_POLL_MASK)

#define MD_REG_MODE_MASK                                                   0x00000001
#define MD_REG_MODE_SHIFT                                                   0 
#define GET_MD_REG_MODE_MODE()                                           ((GET_MD_REG_MODE() & MD_REG_MODE_MASK) >> MD_REG_MODE_SHIFT)
#define MD_REG_MODE(x)                                                         (((x) << MD_REG_MODE_SHIFT) & MD_REG_MODE_MASK)

#define MD_R_CRC_START_MASK                                             0x00000002
#define MD_R_CRC_START_SHIFT                                             1 
#define GET_MD_R_CRC_START()                                           ((GET_MD_R_CRC_CTRL() & MD_R_CRC_START_MASK) >> MD_R_CRC_START_SHIFT)
#define MD_R_CRC_START(x)                                                  (((x) << MD_R_CRC_START_SHIFT) & MD_R_CRC_START_MASK)



typedef enum {
    MdWriteData = BIT(0),
    MdGo        = BIT(1),
    MdEndianSwap    = BIT(2),
    MdIdle      = BIT(3)
} MD_CTRL_REG;

/*interrupt status and control bits */
typedef enum {
    MdIntCmdOpcodeError = BIT(1),
    MdIntCmdLengthError = BIT(2),
    MdIntCommandEmpty   = BIT(3),
    MdIntFlashCmdDone   = BIT(4),
    MdInt2B4BModeError  = BIT(5),
} MD_INT_STATUS_REG, MD_INT_CTRL_REG;



/*********The defines releated to MD COMMAND DESCRIPTOR*************/
#define MD_SEQ_LEN_LIMIT        (0x40000000)
#define MD_SEQ_LEN_LIMIT_MASK       (0x3fffffff)

/*********************seq to seq******************************/
#define MOVE_FORWARD        0
#define MOVE_BACKWARD       BIT(7)

#define MD_CONST            BIT(6)
#define MD_VECTOR           (0)

/*Word 1 bit[3:0] : opcode */
#define MD_1B               (0x05)
#define MD_2B               (0x07)
#define MD_4B               (0x0D)

/*Word 1 bit[5:4] : move mode */
#define MD_SS               (0x00) /*seq -> seq */
#define MD_SB               (0x10) /*seq -> blk */
#define MD_BS               (0x20) /*blk -> seq */
#define MD_SS_PITCH         (0x30) /*seq -> seq (pitch) */

#define MD_2B_SS            (MD_SS|MD_2B)
#define MD_2B_SS_PITCH          (MD_SS_PITCH|MD_2B)

#define MD_4B_SS            (MD_SS|MD_4B)
#define MD_4B_SS_PITCH          (MD_SS_PITCH|MD_4B)


/**************************seq->seq with pitch***********************/
#define MD_SRC_PITCH(x)         ((x & 0x1FFF)<<19)
#define MD_MAX_SRC_PITCH        (0x2000)
#define MD_DST_PITCH(x)         ((x & 0x1FFF)<<6)
#define MD_MAX_DST_PITCH        (0x2000)
#define MD_HEIGHT_BLK(x)        ((x & 0x7FF)<<21)
#define MD_MAX_HEIGHT_BLOCK     (0x800)
#define MD_WIDTH_BLK(x)         ((x & 0x3FFF)<<7)
#define MD_MAX_WIDTH_BLOCK      (0x4000)


/************************seq->blk or blk->seq**************************/
#define MD_SEQ_BLK_HEIGHT_BLK(x)      (((x) & 0x7FF) << 21)
#define MD_SEQ_BLK_WIDTH_BLK(x)      (((x) & 0x3FFF) << 6)
#define MD_SEQ_BLK_Y_BLK(x)      (((x) & 0xFFF) << 20)      
#define MD_SEQ_BLK_X_BLK(x)      (((x) & 0x1FFF) << 6)  
#define MD_SEQ_BLK_ADDR_INDEX(x)      (((x) & 0x3F) << 20)  
#define MD_SEQ_BLK_PITCH_MODE(x)      (((x) & 0x1) << 31) 
#define MD_SEQ_BLK_LENGTH_SEQ(x)      (((x)) << 0) 


#endif
